//----------------------------------------------- 2014-12-11 --------
// Digital Potentiometer Test Program  MCP4151-502(5k ohm)
//------------------------------ written by iizuka   Japan ----------
#include <SPI.h>

#define DPOT_CS     8   // digital 8pin

//------------------------------------------------------------------------------------------
// DPOT に書き込む
//------------------------------------------------------------------------------------------
void spi_dpot_write_16bit( byte data1, byte data2 )
{
  digitalWrite( DPOT_CS, LOW  );    // MCP4151 chip select enable 
  SPI.transfer( data1 );
  SPI.transfer( data2 );
  digitalWrite( DPOT_CS, HIGH );    // MCP4151 chip select disable   
}

void spi_dpot_write_8bit( byte data )
{
  digitalWrite( DPOT_CS, LOW  );    // MCP4151 chip select enable 
  SPI.transfer( data );
  digitalWrite( DPOT_CS, HIGH );    // MCP4151 chip select disable   
}

//------------------------------------------------------------------------------------------
// arduino setup
//------------------------------------------------------------------------------------------  
void setup()
{
  SPI.begin();

  pinMode(DPOT_CS, OUTPUT);
  digitalWrite( DPOT_CS, HIGH );   // MCP4151 disable
}

//------------------------------------------------------------------------------------------
// arduino loop
//------------------------------------------------------------------------------------------  
void loop()
{
  spi_dpot_write_16bit( 0b00000000, 0b00000000 );   // P0A <-> P0W set 5k ohm
  for( byte i = 1 ; i <= 128 ; i++ ) {              // P0A <-> P0W 5.0k ohm -> 2.5k ohm
    delay(20);
    spi_dpot_write_8bit( 0b00000100 );              // inclement wiper
  }
  delay(2000);
  spi_dpot_write_16bit( 0b00000000, 0b00000000 );   // P0A <-> P0W set 5k ohm
  delay(2000);
  spi_dpot_write_16bit( 0b00000000, 0b11111111 );   // P0A <-> P0W set 0k ohm
  delay(2000);
  for( byte i = 0 ; i <= 256 ; i++ ) {              // P0A <-> P0W 0k ohm -> 5k ohm
    delay(20);
    spi_dpot_write_8bit( 0b00001000 );              // declement wiper
  }
  while( true ) {}
}

//--------- E N D  O F  P R O G R A M -------------------------------------------

